#!/usr/bin/env python3
# Copyright (c) 2018-2019 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.
# Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG

from pysys.basetest import BaseTest
from os import path


class ApamaBaseTest(BaseTest):
	"""
	A custom PySys basetest for Apama tests.

	"""

	def __init__(self, descriptor, outsubdir, runner):
		super(ApamaBaseTest, self).__init__(descriptor, outsubdir, runner)

	def getDefaultFileEncoding(self, file, **xargs):
		filename, file_extension = path.splitext(file)

		# give first priority to super-class since for projects created with 
		# PySys 1.4.0+ these will be configured through the pysysproject.xml 
		# instead; this code is only for pre-Apama 10.5 project configs
		delegated = super(ApamaBaseTest, self).getDefaultFileEncoding(file, **xargs)
		if delegated: return delegated
		
		if file_extension in ['xml', 'yaml', 'json', 'log']:
			return 'utf-8'
		else: 
			return None
